import java.util.*;

public class Check
{
	public static final int MINN = 2;
	public static final int MAXN = 10000;

    public static short [][] arr;
	public static int [] num;
	public static boolean [] visited;

	public static void printError(int line, String msg)
	{
		System.out.println("ERROR Line " + line + ": " + msg);
		System.exit(-1);
	}

    public static boolean isATree(int v, int prev, int n)
    {
        if (visited[v])
            return false;
        visited[v] = true;
        for(int i=0; i<num[v]; i++) {
            if (arr[v][i] == prev)
                continue;
            if (!isATree(arr[v][i], v, n))
                return false;
        }
        return true;
    }
	public static void main(String [] args)
	{
		Scanner in = new Scanner(System.in);
		int n, nLines = 1;
		int v1, v2;
		String line;

		n = in.nextInt();
		if (n < MINN || n > MAXN)
			printError(nLines, "n value out of range: " + n);
		line = in.nextLine();
		arr = new short[n+1][n+1];
		num = new int[n+1];
		visited = new boolean[n+1];
		for(int i=0; i<=n; i++) {
            num[i] = 0;
            visited[i] = false;
		}
		while (in.hasNext()) {
			line = in.nextLine();
			nLines++;
			StringTokenizer st = new StringTokenizer(line);
			if (st.countTokens() != 2)
				printError(nLines, "number of values on line incorrect");

			v1 = Integer.parseInt(st.nextToken());
			v2 = Integer.parseInt(st.nextToken());
			if (v1 < 0 || v1 > n)
				printError(nLines, "invalid v1 value: " + v1);
			if (v2 < 0 || v2 > n)
				printError(nLines, "invalid v2 value: " + v2);
            for(int i=0; i<num[v1]; i++)
                if (arr[v1][i] == v2)
                    printError(nLines, "duplicate edge " + v1 + "," + v2);
            arr[v1][num[v1]] = (short)v2;
            arr[v2][num[v2]] = (short)v1;
            num[v1]++;
            num[v2]++;
		}
		if (nLines != n+1)
			printError(nLines, "incorrect number of lines");
        if (!isATree(0, -1, n+1))
            printError(nLines, "edges do not form a tree");
System.exit(42);
	}
}

