import java.util.*;

public class Tracks {

	public static final int MAX = 10000;

	public static Node [] nodes = new Node[MAX+1];
	public static int maxIndex;
	public static int count;

	public static void dfs(int index, int prev, int n) // n = number of vertices-1
	{
	    Node nod = nodes[index];
	    long np = 0;
	    long sum = n;
	    nod.size = 1;
	    long large1=-1, large2=-1;
	    for(Iterator<Integer> it = nod.children.iterator(); it.hasNext(); ) {
	    	int itval= it.next();
	        if (itval == prev)
	            continue;
	        dfs(itval, index, n);
	        long val = nodes[itval].size;
	        sum -= val;
	        nod.size += val;
	        np += val*(n-val);
	        if (val > large1) {
	            large2 = large1;
	            large1 = val;
	        }
	        else if (val > large2)
	            large2 = val;
	    }
	    np += sum*(n-sum);
	    if (sum > large1) {
	        large2 = large1;
	        large1 = sum;
	    }
	    else if (sum > large2)
	        large2 = sum;
	    nod.npairs = np/2;
	    nod.npairs2 = np/2-large1*large2;
	    if (maxIndex == -1) {
	        maxIndex = index;
	        count = 1;
	    }
	    else if (nod.npairs > nodes[maxIndex].npairs) {
	        maxIndex = index;
	        count = 1;
	    }
	    else if (nod.npairs == nodes[maxIndex].npairs) {
	        count++;
	    }
	}

	public static void  main(String [] args)
	{
	    int n;
	    Scanner in = new Scanner(System.in);

	    for(int i=0; i<MAX+1; i++)
	    	nodes[i] = new Node();
	    n = in.nextInt();
	    int n1, n2;
	    for(int i=0; i<n; i++) {
	        n1 = in.nextInt();
	        n2 = in.nextInt();
	        nodes[n1].children.add(n2);
	        nodes[n2].children.add(n1);
	    }
	    maxIndex = -1;
	    count = 0;
	    dfs(0, -1, n);
	    if (count > 1) {
	        System.out.println("ERROR: duplicate answers");
	    }
	    else {
	    	System.out.println(nodes[maxIndex].npairs + " " + nodes[maxIndex].npairs2);
	    }
	    in.close();
	}

}

class Node {
    public Vector<Integer> children;
    public int size;
    public long npairs;
    public long npairs2;
    
    public Node()
    {
    	children = new Vector<Integer>();
    	size = 0;
    	npairs = npairs2 = 0;
    }
}


