import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class KeepingOnTrackDavidTLE 
{
	static Junction[] junctions;
	
	public static void main(String[] args) 
	{
		Scanner scan = new Scanner(System.in);
		int numLines = scan.nextInt();
		int numJunctions = numLines + 1;
		junctions = new Junction[numJunctions];
		
		for (int i = 0; i < numJunctions; i++)
		{
			junctions[i] = new Junction();
		}
		
		for (int i = 0; i < numLines; i++)
		{
			int a = scan.nextInt();
			int b = scan.nextInt();
			
			junctions[a].connections.add(junctions[b]);
			junctions[b].connections.add(junctions[a]);
		}
		
		scan.close();
		
		for (int i = 0; i < numJunctions; i++)
		{
			CalculateJunctionValue(junctions[i]);
		}
		
		int criticalJunctionValue = -1;
		int criticalJunctionFixedValue = -1;
		
		for (int i = 0; i < numJunctions; i++)
		{
			if (junctions[i].value > criticalJunctionValue)
			{
				criticalJunctionValue = junctions[i].value;
				criticalJunctionFixedValue = junctions[i].value - junctions[i].fixedValue;
			}
		}
		
		System.out.println(criticalJunctionValue + " " + criticalJunctionFixedValue);
	}
	
	private static void CalculateJunctionValue(Junction junction)
	{
		ArrayList<Integer> connectionValues = new ArrayList<Integer>();
		
		for (Junction connection : junction.connections)
		{
			connectionValues.add(CalculateSubtreeValue(junction, connection));
		}
		
		int totalValue = 0;
		int bestFixed = -1;
		for (int i = 0; i < connectionValues.size() - 1; i++)
		{
			for (int j = i + 1; j < connectionValues.size(); j++)
			{
				int fixed = connectionValues.get(i) * connectionValues.get(j);
				if (fixed > bestFixed)
				{
					bestFixed = fixed;
				}
				
				totalValue += fixed;
			}
		}
		
		junction.value = totalValue;
		junction.fixedValue = bestFixed;
	}

	private static Integer CalculateSubtreeValue(Junction doNotRevisit, Junction startingJunction) 
	{
		ArrayList<Integer> connectionValues = new ArrayList<Integer>();
		
		for (Junction connection : startingJunction.connections)
		{
			if (!connection.equals(doNotRevisit))
			{
				connectionValues.add(CalculateSubtreeValue(startingJunction, connection));				
			}
		}
		
		int numConnections = 1;
		for (int i = 0; i < connectionValues.size(); i++)
		{
			numConnections += connectionValues.get(i);
		}
		
		return numConnections;
	}
	
	public static class Junction
	{
		public List<Junction> connections = new ArrayList<Junction>();
		public int value;
		public int fixedValue;
	}
}
